function trans()
    require "import"
    import "android.net.Uri"
    import "android.text.Html"
    import "com.androlua.Http"
    import "java.util.Locale"

    -- بدء الإملاء الصوتي
    local luajava = require("luajava")
    local Context = luajava.bindClass("android.content.Context")
    local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
    local Intent = luajava.bindClass("android.content.Intent")
    local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
    local Activity = luajava.bindClass("android.app.Activity")
    local activity = this

    function startVoiceRecognition(activity)
        local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)
        local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
        intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
        intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ar-SA")

        local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
            onReadyForSpeech = function(params)
                -- جاهز للإملاء الصوتي
            end,
            onResults = function(params)
                local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
                local text = results.get(0)

                -- التحقق من وجود النص الملتقط
                if text and text ~= "" then
                    local language = "english"
                    local defaultLanguage = Locale.getDefault().getLanguage()
local languageCodes = { ["english"] = "en" }

                    local languageCode = languageCodes[language]
                    if languageCode then
                        local wordsToTranslate = text
                        local translatedWords = ""
                        
                        local url = "https://translate.google.com/m?sl=auto&hl=" .. defaultLanguage .. "&q=" .. Uri.encode(wordsToTranslate)
                        url = url .. "&tl=" .. languageCode
                        
                        Http.get(url, function(status, result)
                            if status == 200 then
                                translatedWords = result:match('<div class="result%-container">([^<]+)</div>')
                                translatedWords = Html.fromHtml(translatedWords).toString()
                                service.paste(translatedWords .. ". ")
                                this.speak(translatedWords)
                            end
                        end)
                    end
                else
                    this.speak("لم يتم التقاط أي نص.")
                end
            end
        })

        recognizer.setRecognitionListener(recognitionListener)
        recognizer.startListening(intent)
    end

    startVoiceRecognition(activity)
end

-- استدعاء الوظيفة
trans()